<template>
  <q-btn flat stretch>
    <q-avatar size="35px" >
      <img :src="userAvatar">
    </q-avatar>
    <q-menu class="q-mr-lg">
      <q-card style="min-width: 100px;" class="text-left">
        <q-card-section class="q-px-xs">
          <q-list dense>
            <q-item class=" text-left">
              <q-item-section class="q-pa-none q-ma-none">
                <q-item-label>{{ userFullname }}</q-item-label>
                <q-item-label caption>({{ username }})</q-item-label>
              </q-item-section>
            </q-item>
            <q-separator/>
            <q-item dense clickable v-ripple>
              <q-item-section class="q-pa-none q-ma-none">
                Mon Profile
              </q-item-section>
            </q-item>
            <q-item dense clickable v-ripple>
              <q-item-section class="q-pa-none q-ma-none" @click="changePassword">
                Modifier votre mot de passe
              </q-item-section>
            </q-item>
            <q-item dense clickable v-ripple>
              <q-item-section class="q-pa-none q-ma-none text-red-8" @click="disconnectUser">
                Se deconnecter
              </q-item-section>
            </q-item>
          </q-list>
        </q-card-section>
      </q-card>
    </q-menu>
  </q-btn>
</template>

<script>
import {mapState} from "vuex";
import PasswordChangeDialog from "pages/authentication/components/PasswordChangeDialog";

export default {
  name: 'AppUserInfo',

  methods: {
    disconnectUser() {
      this.$q.dialog({
        message: 'Êtes-vous sûr de vouloir partir ?',
        title: 'Confirmation',
        persistent: true,
        cancel: true,
      }).onOk(async () => {
        await this.$store.dispatch('auth/logout')
          .then(() => {
            this.$router.push('/login')
          })
      })
    },

    changePassword() {
      this.$q.dialog({
        parent: this,
        component: PasswordChangeDialog,
        state: 'create',
      })
    },
  },

  computed: {
    username() {
      return _.get(this.currentUser, 'email', 'Inconnu') || 'Inconnu'
    },

    userFullname() {
      return _.get(this.currentUser, 'full_name', 'Inconnu') || 'Inconnu'
    },

    userAvatar() {
      return _.get(this.currentUser, 'avatar', this.defaultAvatar) || this.defaultAvatar
    },

    ...mapState({
      currentUser: state => state.auth.user,
      defaultAvatar: state => state.application.defaultAvatar,
    })
  },
}
</script>
